Bug 1569920 - Allows composition of key values from multiple TripleO services
Summary: Allows composition of key values from multiple TripleO services
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat OpenStack
Classification: Red Hat
Component: openstack-tripleo-heat-templates
Version: 14.0 (Rocky)
Hardware: Unspecified
OS: Unspecified
medium
medium
Target Milestone: Upstream M2
: 14.0 (Rocky)
Assignee: Giulio Fidente
QA Contact: Gurenko Alex
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-04-20 09:26 UTC by Giulio Fidente
Modified: 2019-01-11 11:49 UTC (History)
5 users (show)

Fixed In Version: openstack-tripleo-heat-templates-9.0.0-0.20180710202746.d2994ca.el7ost
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-01-11 11:49:31 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
OpenStack gerrit 563112 0 None None None 2018-04-24 13:42:07 UTC
Red Hat Product Errata RHEA-2019:0045 0 None None None 2019-01-11 11:49:53 UTC

Description Giulio Fidente 2018-04-20 09:26:09 UTC
We should be able to compose the value of a config key from multiple TripleO services.

This would be useful in scenarios like [1], where for example the list of keyrings to be provisioned on the nodes, defined by the single opentack_keys parameter, would be built concatenating values coming from multiple (but only enabled) services instead of being a single list provisioning all keyrings regardless of which service is enabled.

Currently if the same key is defined by multiple services its value is set to the last one parsed/merged. 

1. https://github.com/openstack/tripleo-heat-templates/blob/master/docker/services/ceph-ansible/ceph-base.yaml#L250

Comment 1 Giulio Fidente 2018-04-20 13:56:08 UTC
I am attempting a proper fix for this, in Director, in https://review.openstack.org/#/c/563112/

Comment 7 Artem Hrechanychenko 2019-01-08 14:12:26 UTC
Hi  Giulio,
can you provide some example about how to verify that issue ?

Comment 9 Giulio Fidente 2019-01-11 08:51:09 UTC
(In reply to Artem Hrechanychenko from comment #7)
> Hi  Giulio,
> can you provide some example about how to verify that issue ?

There was a DNM submission in gerrit meant to test this functionality https://review.openstack.org/#/c/572070

In that submission we're setting different values for the same hiera key in two different services. While the CI logs have been deleted, if you look at my comments in that submission you'll see that on the nodes the value set for the keys have been merged to include all values set by each of the service and this was the purpose of the RFE.

This is something we use for a few services but not something that users interact directly with, for example it does not apply to environment files.

One of the potential benefits for the user of this RFE is that for example we don't need to create all the Ceph pools at once anymore (like the Cinder's volume backups pool), but while the RFE has landed the restructuring of the TripleO Ceph services hasn't happened yet.

Comment 10 errata-xmlrpc 2019-01-11 11:49:31 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHEA-2019:0045


Note You need to log in before you can comment on or make changes to this bug.